clc; clear; close all
dirNameImg='D:\Video-databases\PURE\images';
dirNameRef='D:\Video-databases\PURE\reference signals';
deltaThresh=0;
[listImages,listReference]=C01ExtractPaths(dirNameImg,dirNameRef,deltaThresh);
FsCam=30;
FsRef=60;
FsHRV=60;

%% Group indeces of the recordings that belong to the same recording settings
indexCases=cell(1,6);

for i=1:length(listImages)
    if listImages{i}(end-1:end)=='01'
        indexCases{1}=[indexCases{1},i];
    elseif listImages{i}(end-1:end)=='02'
        indexCases{2}=[indexCases{2},i];
    elseif listImages{i}(end-1:end)=='03'
        indexCases{3}=[indexCases{3},i];
    elseif listImages{i}(end-1:end)=='04'
        indexCases{4}=[indexCases{4},i];
    elseif listImages{i}(end-1:end)=='05'
        indexCases{5}=[indexCases{5},i];
    elseif listImages{i}(end-1:end)=='06' 
        indexCases{6}=[indexCases{6},i];
    end
end

%% Find peaks

% load data
load('D:\MatlabKoda\02-SB_CWT-HRV\rezultati\refInterp.mat');
load('D:\MatlabKoda\02-SB_CWT-HRV\rezultati\rPPGresamp.mat');

% variable preallocation
peaksRef=cell(1,length(listImages));
locsRef=cell(1,length(listImages));
peaksRPPG=cell(1,length(listImages));
locsRPPG=cell(1,length(listImages));

% peak detection
for i=1:length(listImages)
    [peaksRef{i},locsRef{i},~,~] = findpeaks(refInterp{i},FsHRV,'MinPeakprominence',10,'MinPeakDistance',1/(180/60));
    [peaksRPPG{i},locsRPPG{i},~,~] = findpeaks(rPPGresamp{i},FsHRV,'MinPeakDistance',1/(240/60),'MinPeakHeight',1); % find x locations of peaks of the SB-CWT pulse signal
    disp(i)
end

%% Refine peaks

for i=1:length(listImages)
    [peaksRefNew{i},locsRefNew{i}]=C07PeakRefinement(peaksRef{i},locsRef{i});
    [peaksRPPGNew{i},locsRPPGNew{i}]=C07PeakRefinement(peaksRPPG{i},locsRPPG{i});
    disp(i)
end

%% Extraction of pulse signal intervals

allIntervals={'10s','10m','10e','30s','30e','60'};
% variable preallocation
rPPGF=cell(length(listImages),length(allIntervals));
refF=cell(length(listImages),length(allIntervals));
locsF=cell(length(listImages),length(allIntervals));
peaksF=cell(length(listImages),length(allIntervals));
locsrefF=cell(length(listImages),length(allIntervals));
peaksrefF=cell(length(listImages),length(allIntervals));

for i=1:length(listImages)
    for j=1:length(allIntervals)
        intervalL=allIntervals{j};
         [rPPGF{i,j},refF{i,j},locsF{i,j},peaksF{i,j},locsrefF{i,j},peaksrefF{i,j}] = C08ExtractPulseSignalInterval...
        (intervalL,rPPGresamp{i},locsRPPGNew{i},peaksRPPGNew{i},refInterp{i},locsRefNew{i},peaksRefNew{i},FsHRV);
         [rPPGF1{i,j},refF1{i,j},locsF1{i,j},peaksF1{i,j},locsrefF1{i,j},peaksrefF1{i,j}] = C08ExtractPulseSignalInterval...
        (intervalL,rPPGresamp{i},locsRPPG{i},peaksRPPG{i},refInterp{i},locsRef{i},peaksRef{i},FsHRV);
    disp(i),disp(j)
    end
end

for i=1:length(listImages)
     [rPPGF1{i},refF1{i},locsF1{i},peaksF1{i},locsrefF1{i},peaksrefF1{i}] = C08ExtractPulseSignalInterval...
     ('60',rPPGresamp{i},locsRPPG{i},peaksRPPG{i},refInterp{i},locsRef{i},peaksRef{i},FsHRV);
end

%% Calculation of HRV parameters - SDNN, RMSSD and pNN50 (latter only for 60 s recordings)

%variable preallocation
SDNNrPPG=zeros(length(allIntervals),length(listImages));
RMSSDrPPG=zeros(length(allIntervals),length(listImages));
SDNNref=zeros(length(allIntervals),length(listImages));
RMSSDref=zeros(length(allIntervals),length(listImages));
pNN50rPPG=zeros(length(allIntervals),length(listImages));
pNN50rPPG1=zeros(length(allIntervals),length(listImages));
pNN50ref=zeros(length(allIntervals),length(listImages));
pNN50ref1=zeros(length(allIntervals),length(listImages));

for i = 1:length(listImages)
    for j=1:length(allIntervals)
        %after peak refinement
        [SDNNrPPG(j,i),RMSSDrPPG(j,i),RRrPPG{j,i}] = C09HRV(locsF{i,j});
        [SDNNref(j,i),RMSSDref(j,i),RRref{j,i}] = C09HRV(locsrefF{i,j});
        %before peak refinement
        [SDNNrPPG1(j,i),RMSSDrPPG1(j,i),RRrPPG1{j,i}] = C09HRV(locsF1{i,j});
        [SDNNref1(j,i),RMSSDref1(j,i),RRref1{j,i}] = C09HRV(locsrefF1{i,j});
        if j==4 || j==5 || j==6
            %after peak refinement
            pNN50rPPG(j,i)=C10pNN50(locsF{i,j});
            pNN50ref(j,i)=C10pNN50(locsrefF{i,j});
            %before peak refinement
            pNN50rPPG1(j,i)=C10pNN50(locsF1{i,j});
            pNN50ref1(j,i)=C10pNN50(locsrefF1{i,j});
        end
    end
end
%%

[SDNNrefC,SDNNrPPGC,RMSSDrefC,RMSSDrPPGC,pNN50refC,pNN50rPPGC]...
    =groupValues(SDNNref,SDNNrPPG,RMSSDref,RMSSDrPPG,indexCases,pNN50ref,pNN50rPPG);

[SDNNrefC1,SDNNrPPGC1,RMSSDrefC1,RMSSDrPPGC1,pNN50refC1,pNN50rPPGC1]...
    =groupValues(SDNNref1,SDNNrPPG1,RMSSDref1,RMSSDrPPG1,indexCases,pNN50ref1,pNN50rPPG1);

[meanpNN50refC,stdpNN50refC,meanpNN50rPPGC,stdpNN50rPPGC,...
    meanSDNNrefC,stdSDNNrefC,meanSDNNrPPGC,stdSDNNrPPGC,...
    meanRMSSDrefC,stdRMSSDrefC,meanRMSSDrPPGC,stdRMSSDrPPGC]...
    =meanGroupValues(pNN50refC,pNN50rPPGC,SDNNrefC,SDNNrPPGC,RMSSDrefC,RMSSDrPPGC);

[meanpNN50refC1,stdpNN50refC1,meanpNN50rPPGC1,stdpNN50rPPGC1,...
    meanSDNNrefC1,stdSDNNrefC1,meanSDNNrPPGC1,stdSDNNrPPGC1,...
    meanRMSSDrefC1,stdRMSSDrefC1,meanRMSSDrPPGC1,stdRMSSDrPPGC1]...
    =meanGroupValues(pNN50refC1,pNN50rPPGC1,SDNNrefC1,SDNNrPPGC1,RMSSDrefC1,RMSSDrPPGC1);

% filename1 = 'SDNN_RMSSD_pNN50_N.xlsx';
% xlswrite(filename1,meanSDNNrefC,'SDNN','A1')
% xlswrite(filename1,stdSDNNrefC,'SDNN', 'H1')
% xlswrite(filename1,meanSDNNrPPGC,'SDNN','A10')
% xlswrite(filename1,stdSDNNrPPGC,'SDNN', 'H10')
% xlswrite(filename1,meanRMSSDrefC,'RMSSD','A1')
% xlswrite(filename1,stdRMSSDrefC,'RMSSD', 'H1')
% xlswrite(filename1,meanRMSSDrPPGC,'RMSSD','A10')
% xlswrite(filename1,stdRMSSDrPPGC,'RMSSD', 'H10')
% 
% xlswrite(filename1,meanpNN50refC,'pNN50', 'A1')
% xlswrite(filename1,meanpNN50rPPGC,'pNN50', 'A2')

%%
for i=1:size(SDNNrefC,1)
    tempSDNNref(i,:)=[SDNNrefC{i,1},SDNNrefC{i,2},SDNNrefC{i,3},SDNNrefC{i,4},SDNNrefC{i,5},SDNNrefC{i,6}];
    tempSDNNrPPG(i,:)=[SDNNrPPGC{i,1},SDNNrPPGC{i,2},SDNNrPPGC{i,3},SDNNrPPGC{i,4},SDNNrPPGC{i,5},SDNNrPPGC{i,6}];
    tempRMSSDref(i,:)=[RMSSDrefC{i,1},RMSSDrefC{i,2},RMSSDrefC{i,3},RMSSDrefC{i,4},RMSSDrefC{i,5},RMSSDrefC{i,6}];
    tempRMSSDrPPG(i,:)=[RMSSDrPPGC{i,1},RMSSDrPPGC{i,2},RMSSDrPPGC{i,3},RMSSDrPPGC{i,4},RMSSDrPPGC{i,5},RMSSDrPPGC{i,6}];
    temppNN50ref(i,:)=[pNN50refC{i,1},pNN50refC{i,2},pNN50refC{i,3},pNN50refC{i,4},pNN50refC{i,5},pNN50refC{i,6}];
    temppNN50rPPG(i,:)=[pNN50rPPGC{i,1},pNN50rPPGC{i,2},pNN50rPPGC{i,3},pNN50rPPGC{i,4},pNN50rPPGC{i,5},pNN50rPPGC{i,6}];
    
    [pSDNN(i),~,~]=anova1([tempSDNNref(i,:)',tempSDNNrPPG(i,:)']);
    [plnSDNN(i),~,~]=anova1([log(tempSDNNref(i,:))',log(tempSDNNrPPG(i,:))']);
    [pRMSSD(i),~,~]=anova1([tempRMSSDref(i,:)',tempRMSSDrPPG(i,:)']);
    
    meanSDNNrefC(i)=mean(tempSDNNref(i,:)); stdSDNNrefC(i)=std(tempSDNNref(i,:));
    meanSDNNrPPGC(i)=mean(tempSDNNrPPG(i,:)); stdSDNNrPPGC(i)=std(tempSDNNrPPG(i,:));
    meanlnSDNNrefC(i)=mean(log(tempSDNNref(i,:))); stdlnSDNNrefC(i)=std(log(tempSDNNref(i,:)));
    meanlnSDNNrPPGC(i)=mean(log(tempSDNNrPPG(i,:))); stdlnSDNNrPPGC(i)=std(log(tempSDNNrPPG(i,:)));
    meanRMSSDrefC(i)=mean(tempRMSSDref(i,:)); stdRMSSDrefC(i)=std(tempRMSSDref(i,:));
    meanRMSSDrPPGC(i)=mean(tempRMSSDrPPG(i,:)); stdRMSSDrPPGC(i)=std(tempRMSSDrPPG(i,:));
    
    if i>4
        meanpNN50refC(i-4)=mean(temppNN50ref(i,:)); stdpNN50refC(i-4)=mean(temppNN50ref(i,:));
        meanpNN50rPPGC(i-4)=mean(temppNN50rPPG(i,:)); stdpNN50rPPGC(i-4)=mean(temppNN50rPPG(i,:));
        [ppNN50(i-4),tab,stats]=anova1([temppNN50ref(i,:)',temppNN50rPPG(i,:)']);
    end
    
end

for i=1:size(meanSDNNrefC,2)
    fprintf('%.2f$\\pm$%.2f ', meanSDNNrefC(i), stdSDNNrefC(i))
end
fprintf('\n')

for i=1:size(meanSDNNrefC,2)
    fprintf('%.2f$\\pm$%.2f ', meanSDNNrPPGC(i), stdSDNNrPPGC(i))
end
fprintf('\n')

for i=1:size(meanSDNNrefC,2)
    fprintf('%.2f$\\pm$%.2f ', meanlnSDNNrefC(i), stdlnSDNNrefC(i))
end
fprintf('\n')

for i=1:size(meanSDNNrefC,2)
    fprintf('%.2f$\\pm$%.2f ', meanlnSDNNrPPGC(i), stdlnSDNNrPPGC(i))
end
fprintf('\n')

for i=1:size(meanSDNNrefC,2)
    fprintf('%.2f$\\pm$%.2f ', meanRMSSDrefC(i), stdRMSSDrefC(i))
end
fprintf('\n')

for i=1:size(meanSDNNrefC,2)
    fprintf('%.2f$\\pm$%.2f ', meanRMSSDrPPGC(i), stdRMSSDrPPGC(i))
end
fprintf('\n')

for i=1:size(meanpNN50refC,2)
    fprintf('%.2f$\\pm$%.2f ', meanpNN50refC(i), stdpNN50refC(i))
end
fprintf('\n')

for i=1:size(meanpNN50refC,2)
    fprintf('%.2f$\\pm$%.2f ', meanpNN50rPPGC(i), stdpNN50rPPGC(i))
end
fprintf('\n')

% fprintf('\n')
% fprintf('%.2f ', meanSDNNrPPGC)
% fprintf('\n')
% fprintf('%.2f ', meanRMSSDrefC)
% fprintf('\n')
% fprintf('%.2f ', meanRMSSDrPPGC)
% fprintf('\n')
% fprintf('%.2f ', meanpNN50refC)
% fprintf('\n')
% fprintf('%.2f ', meanpNN50rPPGC)

%% relative difference MAE (SDNN, RMSSD, pNN50) before and after the peak refinement
% 
% for j=1:size(SDNNrefC,1)
%     MAESDNN(j)=sum(abs([SDNNrefC{8,:}]-[SDNNrPPGC{j,:}]))/length([SDNNrefC{8,:}]);
%     MAESDNN1(j)=sum(abs([SDNNrefC1{8,:}]-[SDNNrPPGC1{j,:}]))/length([SDNNrefC1{8,:}]);
%     MAESDNNdiff(j)=(MAESDNN(j)-MAESDNN1(j))/MAESDNN1(j);
%     MAERMSSD(j)=sum(abs([RMSSDrefC{8,:}]-[RMSSDrPPGC{j,:}]))/length([RMSSDrefC{8,:}]);
%     MAERMSSD1(j)=sum(abs([RMSSDrefC1{8,:}]-[RMSSDrPPGC1{j,:}]))/length([RMSSDrefC1{8,:}]);
%     MAERMSSDdiff(j)=(MAERMSSD(j)-MAERMSSD1(j))/MAERMSSD1(j);
%     MAEpNN50(j)=sum(abs([pNN50refC{8,:}]-[pNN50rPPGC{j,:}]))/length([pNN50refC{8,:}]);
%     MAEpNN501(j)=sum(abs([pNN50refC1{8,:}]-[pNN50rPPGC1{j,:}]))/length([pNN50refC1{8,:}]);
%     MAEpNN50diff(j)=(MAEpNN50(j)-MAEpNN501(j))/MAEpNN501(j);
% end
% 
% 
% % filename2='peakRefineEvaluation.xlsx';
% % 
% % xlswrite(filename2,MAESDNNdiff,'MAE','A1')
% % xlswrite(filename2,MAERMSSDdiff,'MAE','A2')
% % xlswrite(filename2,MAEpNN50diff,'MAE','A3')
% % 
% % xlswrite(filename2,MAESDNN,'MAE','A9')
% % xlswrite(filename2,MAERMSSD,'MAE','A10')
% % xlswrite(filename2,MAEpNN50,'MAE','A11')
% 
% %% Save variables to file
% 
% save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\HRV\','SDNNrefC.mat'),'SDNNrefC')
% save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\HRV\','SDNNrPPGC.mat'),'SDNNrPPGC')
% save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\HRV\','RMSSDrefC.mat'),'RMSSDrefC')
% save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\HRV\','RMSSDrPPGC.mat'),'RMSSDrPPGC')
% save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\HRV\','pNN50refC.mat'),'pNN50refC')
% save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\HRV\','pNN50rPPGC.mat'),'pNN50rPPGC')