%%
clc
clear
close all

% SIGNALS
% Reference signals (refRaw in tPPGsec): each folder in D:\Video-databases\PURE\images\
% Raw rPPG signals (C in trPPGsec): each folder in D:\Video-databases\PURE\images\
% Preprocessed reference signals (refFilt-60Hz,refInterp-1000Hz,refSNR-60Hz): D:\MatlabKoda\02-testDrugiClanek\rezultati\
% Pulse signals (rPPG): D:\MatlabKoda\02-testDrugiClanek\rezultati\
% SNR (SNRrPPG): D:\MatlabKoda\02-testDrugiClanek\rezultati\
% Processed rPPG (rPPGresasmp): D:\MatlabKoda\02-testDrugiClanek\rezultati\

% PLOTS
% Raw rPPG signals plots: D:\MatlabKoda\02-testDrugiClanek\rezultati\rawrPPG\
% Results of face detection: D:\MatlabKoda\02-testDrugiClanek\rezultati\results face detector\

%% Extract paths of images from video recordings and reference files

dirNameImg='D:\Video-databases\PURE\images';
dirNameRef='D:\Video-databases\PURE\reference signals';
deltaThresh=0;
[listImages,listReference]=C01ExtractPaths(dirNameImg,dirNameRef,deltaThresh);

%% Extract reference signals
% Reference signals (refRaw in tPPGsec): each folder in D:\Video-databases\PURE\images\

for i=1:length(listImages)
    C02ExtractReference(listImages,listReference,i);
end

%% Extract raw rPPG signals from video recordings
% Raw rPPG signals (C in trPPGsec): each folder in D:\Video-databases\PURE\images\

faceDetector = vision.CascadeObjectDetector('FrontalFaceCART');
for i=1:length(listImages)
    C03ExtractrPPG(listImages,faceDetector,i);
end

%% Preprocessing of reference signals
% Preprocessed reference signals (refFilt-60Hz,refInterp-1000Hz,refSNR-60Hz): D:\MatlabKoda\02-testDrugiClanek\rezultati\

FsCam=30;
FsRef=60;
FsHRV=60;

[refFilt,refInterp,refSNR]=C04ReferenceProcessing(listImages,FsRef,FsHRV);

%% Pulse signal extraction using SB-CWT from rPPG signals
% Pulse signals (rPPG): D:\MatlabKoda\02-testDrugiClanek\rezultati\

L=256;
timebandwidth=115;

C05ExtractPulseFromrPPG(listImages,FsCam,L,timebandwidth);

%% Processing of pulse signal extracted from rPPG signals
% SNR (SNRrPPG): D:\MatlabKoda\02-testDrugiClanek\rezultati\
% Processed rPPG (rPPGresasmp): D:\MatlabKoda\02-testDrugiClanek\rezultati\

C06rPPGProcessingSNR(listImages,FsCam,FsHRV)