function [P1,f] = A_FFT (x, FsCam, a)

if size(x,1) == 1
    L = size(x,2);
    Y = fft(x);
    P2 = abs(Y/L);
    P1 = P2(1:L/2+1);
    P1(2:end-1) = 2*P1(2:end-1);
    f = FsCam*(0:(L/2))/L;
    
    if strcmp(a,'plot') == 1
        figure('DefaultAxesFontSize',30)
        plot(f,P1), xlim([40/60,240/60])
        xlabel('f[Hz]'), ylabel('Amplituda')
    end
    
elseif size(x,1) == 3
    L = size(x,2);
    F = fft(x,[],2)/L;
    P2 = abs(F);
    P1 = P2(:,1:L/2+1);
    P1(:,2:end-1) = 2*P1(:,2:end-1);
    f = FsCam*(0:(L/2))/L;
    
    if strcmp(a,'plot') == 1
        figure('DefaultAxesFontSize',30)
        h1 = plot(f,P1);
        set(h1, {'color'}, {'r'; 'g'; 'b'});
        xlabel('f[Hz]'), ylabel('Amplituda[/]')
        xlim([0.67,4])
    end
    
end

end
