% Function that extracts full paths of all MMSE-HR recordings
function [listImages,listReference]=C01ExtractPaths(dirNameImg,dirNameRef,deltaThresh)

thresh=length(dirNameImg)+deltaThresh;

listImagesTemp1 = genpath(dirNameImg); % path name of the folderName and all subfolders
listImagesTemp = strsplit(listImagesTemp1,';'); % split listTemp1 with semicolon as the denominator

% change all the paths with thresh or less characters (these paths do not
% include the recordings) to empty matrices
for i=1:size(listImagesTemp,2)
    if size(listImagesTemp{i},2)<=thresh
        listImagesTemp{i}=[];
    end
end

listImages=listImagesTemp(~cellfun('isempty',listImagesTemp)); % remove all the empty matrices


listReference=cell(1,size(listImages,2)); % preallocation of the listPhys that contains paths of all BP signals (used as the reference signals)

for i = 1:size(listImages,2)
    listReference{i}=strcat(dirNameRef,erase(listImages{i},dirNameImg),'.json');
end

end