% Extract rPPG signal
function C03ExtractrPPG(listImages,faceDetector,i)

listImagesT=[listImages{i},'\'];
pngImagesDir=[listImagesT,'*.png'];
pngImages=dir(pngImagesDir);

for k=1:size(pngImages,1)
    filename = strcat(listImagesT,pngImages(k).name);
    img = imread(filename);
    ns=uint64(str2double(filename(43:61)));
    wholeSecs=floor(double(ns)/1e9);
    fracSecs = double(ns - uint64(wholeSecs)*1e9)/1e9;
    trPPG(k) = datetime(wholeSecs,'ConvertFrom','posixTime','Format','HH:mm:ss.SSSSSSSSS') + seconds(fracSecs);
        
        if k == 1
            bbox = step(faceDetector, img);
            if size(bbox,1)>1
                for m=1:size(bbox,1)
                    summa(m)=bbox(m,3)+bbox(m,4);
                end
                [~,maxInd]=max(summa);
                bbox=bbox(maxInd,:);
            end
            bbox(1,1)=round((bbox(1,1)+bbox(1,1)+bbox(1,3))/2-(bbox(1,3)*0.6)/2); % change the x value of the upper left corner of the bbox
            bbox(1,2)=bbox(1,2); % keep the y value of the upper left corner of the bbox
            bbox(1,3)=round(bbox(1,3)*0.6); % reduce the width of the bbox to 60%
            bbox(1,4)=bbox(1,4); % keep the same height of the bbox
            IFaces = insertObjectAnnotation(img,'rectangle',bbox,'Face');
%             imwrite(IFaces,strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\results face detector\',...
%                 listImagesT(length(listImagesT)-5:length(listImagesT)-1),'.jpg'));
            bboxPoints = bbox2points(bbox(1, :));
            points = detectMinEigenFeatures(rgb2gray(img), 'ROI', bbox);
            pointTracker = vision.PointTracker('MaxBidirectionalError', 2);
            points = points.Location;
            initialize(pointTracker, points, img);
            oldPoints = points;            
        end
        
        [points, isFound] = step(pointTracker, img);
        visiblePoints = points(isFound, :);
        oldInliers = oldPoints(isFound, :);
        
        if size(visiblePoints, 1) >= 2 % need at least 2 points
        
        % Estimate the geometric transformation between the old points
        % and the new points and eliminate outliers
        [xform, oldInliers, visiblePoints] = estimateGeometricTransform(...
            oldInliers, visiblePoints, 'similarity', 'MaxDistance', 4);
        
        bboxPoints = transformPointsForward(xform, bboxPoints);
                                   
        BW = roipoly(img,bboxPoints(:,1),bboxPoints(:,2));
        Inew = img.*repmat(uint8(BW),[1,1,3]);
        C(1,k)= sum(sum(Inew(:,:,1),1),2)/(sum(Inew(:) ~= 0));
        C(2,k)= sum(sum(Inew(:,:,2),1),2)/(sum(Inew(:) ~= 0));
        C(3,k)= sum(sum(Inew(:,:,3),1),2)/(sum(Inew(:) ~= 0));
        % Reset the points
        oldPoints = visiblePoints;
        setPoints(pointTracker, oldPoints);
        end
end

trPPGsec=seconds(trPPG-trPPG(1));
save(strcat(listImagesT,'trPPGsec.mat'),'trPPGsec')
save(strcat(listImagesT,'C.mat'),'C')

% h=figure;
% subplot(311); plot(C(1,:)); subplot(312); plot(C(2,:)); subplot(313); plot(C(3,:)); 
% saveas(h,strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\rawrPPG\',...
%     listImagesT(length(listImagesT)-5:length(listImagesT)-1),'.jpg'))
clear trPPG trPPGsec C
disp(i)

end
