function C05ExtractPulseFromrPPG(listImages,FsCam,L,timebandwidth)

P=cell(1,length(listImages));

for j=1:length(listImages)

    listImagesT=[listImages{j},'\'];
    load(strcat(listImagesT,'C.mat'));
    trPPGsec=load(strcat(listImagesT,'trPPGsec.mat'));

    CC=[];
    CC(1,:) = resample(C(1,:),trPPGsec.trPPGsec,FsCam,'spline');
    CC(2,:) = resample(C(2,:),trPPGsec.trPPGsec,FsCam,'spline');
    CC(3,:) = resample(C(3,:),trPPGsec.trPPGsec,FsCam,'spline');
    
    input=CC;
    N=size(input,2); % length of the input signal
    P{j}=zeros(1,N); % preallocation of the final pulse signal vector

    for n = 1:N-L+1
        W=cell(1,3); % preallocation of the wavelet coefficients vector
        Cw=input(:,n:n+L-1); % windowing
        Cnw=diag(mean(Cw,2))^(-1)*Cw-1; % temporal normalization
            for i=1:3
              [W{i},f]=cwt(Cnw(i,:),'morse',FsCam,'WaveletParameters',[3,timebandwidth]); % CWT
            end
        m = find ((40/60 <= f) & (f <= 240/60)); % find the freq. range that corresponds to [40 240] BPM
        S1=W{2}-W{3}; % project wavelet coefficients on POS (part 1)
        S2=-2*W{1}+W{2}+W{3}; % project wavelet coefficient on POS (part 2)
        h=S1+(abs(S1)./abs(S2)).*S2; % alpha tuning
        %energy=zeros(1,size(h,1)); % preallocation of the weighting function based on scale-dependent energy distribution
            for k=1:size(h,1)
                energy(k)=sum(abs(h(k,:))); % global energy distribution calculation
            end
        Pw=bsxfun(@times,energy,h')'; % weighting
        %Pw=h; % in case of no weight 
        signal=icwt(Pw,'morse',f,[f(m(end)) f(m(1))],'WaveletParameters',[3,timebandwidth]); % perform inverse CWT
        P{j}(1,n:n+L-1)=P{j}(1,n:n+L-1)+(signal-mean(signal))/std(signal); % overlap-add 
    end
    disp(j)
end
rPPG=P;
save(strcat('D:\MatlabKoda\02-testDrugiClanek\rezultati\','rPPG.mat'),'rPPG')

end