function SNR = calcSNR (signal,FsCam,reference,FsRef,L)

N=size(signal,2);
SNR=[];

for i=1:N-L+1
    [Pref,fref] = A_FFT (reference(1,i:i+(L*FsRef/FsCam)-1),FsRef,'noplot'); % FFT analysis
    range=find(fref>40/60&fref<240/60);
    [~,I]=max(Pref(range));
    indexMax=range(1)+I-1;    
    
    [P,f] = A_FFT (signal(1,i:i+L-1),FsCam,'noplot');
    [powerTotal,~]=sumsqr(P(find(f>40/60&f<240/60)));
    [powerSignal,~]=sumsqr(P(indexMax-2:indexMax+2));
    powerRemainder=powerTotal-powerSignal;
    SNRtemp=10*log10(powerSignal/powerRemainder);
    SNR=[SNR;SNRtemp];
    
end

end