%% Group SDNN, RMSSD and pNN50 values by duration

function [SDNNrefC,SDNNrPPGC,RMSSDrefC,RMSSDrPPGC,pNN50refC,pNN50rPPGC]=groupValues(SDNNref,SDNNrPPG,RMSSDref,RMSSDrPPG,indexCases,pNN50ref,pNN50rPPG)

SDNNrefC=cell(8,6);
SDNNrPPGC=cell(8,6);
RMSSDrefC=cell(8,6);
RMSSDrPPGC=cell(8,6);
pNN50refC=cell(1,6);
pNN50rPPGC=cell(1,6);


for i=1:8
    for j=1:6
        if i==4
            SDNNrefC{i,j}=mean([SDNNref(1,indexCases{j});SDNNref(2,indexCases{j});SDNNref(3,indexCases{j})],1);
            SDNNrPPGC{i,j}=mean([SDNNrPPG(1,indexCases{j});SDNNrPPG(2,indexCases{j});SDNNrPPG(3,indexCases{j})],1);
            RMSSDrefC{i,j}=mean([RMSSDref(1,indexCases{j});RMSSDref(2,indexCases{j});RMSSDref(3,indexCases{j})],1); 
            RMSSDrPPGC{i,j}=mean([RMSSDrPPG(1,indexCases{j});RMSSDrPPG(2,indexCases{j});RMSSDrPPG(3,indexCases{j})],1);
            pNN50refC{i,j}=zeros(size(pNN50ref(i,indexCases{j})));
            pNN50rPPGC{i,j}=zeros(size(pNN50rPPG(i,indexCases{j})));
        elseif i==5 || i==6
            SDNNrefC{i,j}=SDNNref(i-1,indexCases{j});
            SDNNrPPGC{i,j}=SDNNrPPG(i-1,indexCases{j});
            RMSSDrefC{i,j}=RMSSDref(i-1,indexCases{j}); 
            RMSSDrPPGC{i,j}=RMSSDrPPG(i-1,indexCases{j});
            pNN50refC{i,j}=pNN50ref(i-1,indexCases{j});
            pNN50rPPGC{i,j}=pNN50rPPG(i-1,indexCases{j});
        elseif i==7
            SDNNrefC{i,j}=mean([SDNNref(4,indexCases{j});SDNNref(5,indexCases{j})],1);
            SDNNrPPGC{i,j}=mean([SDNNrPPG(4,indexCases{j});SDNNrPPG(5,indexCases{j})],1);
            RMSSDrefC{i,j}=mean([RMSSDref(4,indexCases{j});RMSSDref(5,indexCases{j})],1); 
            RMSSDrPPGC{i,j}=mean([RMSSDrPPG(4,indexCases{j});RMSSDrPPG(5,indexCases{j})],1);
            pNN50refC{i,j}=mean([pNN50ref(4,indexCases{j});pNN50ref(5,indexCases{j})],1);
            pNN50rPPGC{i,j}=mean([pNN50rPPG(4,indexCases{j});pNN50rPPG(5,indexCases{j})],1);
        elseif i==8
            SDNNrefC{i,j}=SDNNref(i-2,indexCases{j});
            SDNNrPPGC{i,j}=SDNNrPPG(i-2,indexCases{j});
            RMSSDrefC{i,j}=RMSSDref(i-2,indexCases{j}); 
            RMSSDrPPGC{i,j}=RMSSDrPPG(i-2,indexCases{j});
            pNN50refC{i,j}=pNN50ref(i-2,indexCases{j});
            pNN50rPPGC{i,j}=pNN50rPPG(i-2,indexCases{j});
        else
            SDNNrefC{i,j}=SDNNref(i,indexCases{j});
            SDNNrPPGC{i,j}=SDNNrPPG(i,indexCases{j});
            RMSSDrefC{i,j}=RMSSDref(i,indexCases{j}); 
            RMSSDrPPGC{i,j}=RMSSDrPPG(i,indexCases{j});
            pNN50refC{i,j}=pNN50ref(i,indexCases{j});
            pNN50rPPGC{i,j}=pNN50rPPG(i,indexCases{j});
        end
    end
end

end